program pac_man_procedures;
uses
  crt;

const
  MAXLIN  =24;
  MAXCOL  =80;
  VITAMINA='.';
  MURO  ='*';
  LIVRE =' ';
  PACMAN='$';
  ENEMY ='X';

  UP   = 'U'; { Tecla UP = Seta para cima }
  DOWN = 'D'; { Tecla DOWN = Seta para baixo }
  LEFT = 'L'; { Tecla LEFT = Seta para a esquerda }
  RIGHT= 'R'; { Tecla RIGHT = Seta para a direita }
  QUIT = 'Q'; { Tecla QUIT = Sair do jogo }
  INC  = '+'; { Tecla INC = Aumenta (velocidade? dificuldade?) }
  DEC  = '-'; { Tecla DEC = Diminui }
  NULL = '?'; { Tecla invalida / Nao teclou nada }

var
  maze:array [1..MAXLIN,1..MAXCOL] of char; { Tabela que define o labirinto }

procedure load_maze(nome:string;var totenemy,totvita:integer);
var
  arq:text;
  l,c:integer;
  linha:string[100];
begin
  {
    Labirinto: 24x80
    '*' = Muro, '$' = PacMan, 'X' = Ghosts
  }
  assign(arq,nome);
  reset(arq);
  l:=1;
  totvita:=0;
  totenemy:=0;
  while not eof(arq)
  do begin
       readln(arq,linha);
       writeln(linha);
       if linha[1] <> '#'
       then begin
              if length(linha)>MAXCOL
              then begin
                     clrscr;
                     writeln('>>> Labirinto com muitas colunas! <<<');
                     readln;
                     halt(1);
                   end;
              for c:=1 to length(linha)
              do begin
                   if linha[c]=' '
                   then begin
                          linha[c]:=VITAMINA;
                          totvita:=totvita+1;
                        end;
                   if linha[c]='X'
                   then totenemy:=totenemy+1;
                   maze[l,c]:=linha[c];
                 end;
              l:=l+1;
              if l > MAXLIN+1
              then begin
                     clrscr;
                     writeln('>>> Labirinto com muitas linhas! <<<');
                     readln;
                     halt(1);
                   end;

            end;
     end;
  close(arq);
end;

procedure show_maze;
var
 l,c:integer;
begin
  for l:=1 to MAXLIN
  do for c:=1 to MAXCOL
     do begin
          gotoxy(c,l);
          case maze[l,c] of
             MURO:write(chr(178));
             VITAMINA:write(chr(250));
             PACMAN:write(chr(1));
             ENEMY:write(chr(64));
          end;
        end;
end;

function get_move:char;
var
  tec:char;
  ret:boolean;
begin
  if keypressed
  then tec:=readkey;
  if ord(tec)=0
  then begin
         tec:=readkey;
         if ord(tec)=75      {Esquerda}
         then get_move:=LEFT
         else if ord(tec)=77       {Direita}
              then get_move:=RIGHT
              else if ord(tec)=72      {Cima}
                   then get_move:=UP
                   else if ord(tec)=80       {Baixo}
                        then get_move:=DOWN
                        else get_move:=NULL;
       end
  else if upcase(tec)='Q'
       then get_move:=QUIT
       else if tec='+'
            then get_move:=INC
            else if tec='-'
                 then get_move:=DEC
                 else get_move:=NULL;  { Nenhuma das teclas validas }
end;

var
  tot_vit,tot_ghost:integer;
  loop:boolean;
  count:byte;
  tec:char;
begin
  { Carrega arquivo do disco com o labirinto }
  load_maze('maze.txt',tot_vit,tot_ghost);
  show_maze;             { Exibe labirinto }

  count:=0;
  loop:=true;
  while loop
  do begin
       tec:=get_move;
       gotoxy(3,24);
       write('Tecla pressionada: ',tec);

       { Pequena animacao... para demonstrar como o teclado pode ser
         lido ao mesmo tempo em que outra(s) tarefas sao executadas  }
       gotoxy(1,24);
       if count=0 then write('\');
       if count=1 then write('|');
       if count=2 then write('/');
       if count=3 then write('-');
       count:=count+1;
       if count=4 then count:=0;
       delay(30);

       { Se a tecla 'Q' foi pressionada, termina a execucao do programa }
       if tec=QUIT then loop:=false;

     end;
end.
